Page MenuHomePhabricator

[OpenMP] Fix if0 task with dependencies
ClosedPublic

Authored by jlpeyton on Sep 7 2020, 10:25 PM.

Details

Summary

The current GOMP interface for if0 tasks does not take into
account task dependencies. Add the check and wait for dependencies.

Fixes: https://bugs.llvm.org/show_bug.cgi?id=46573

Diff Detail

Event Timeline

jlpeyton created this revision.Sep 7 2020, 10:25 PM
jlpeyton requested review of this revision.Sep 7 2020, 10:25 PM
jdoerfert added inline comments.Sep 8 2020, 8:04 AM
openmp/runtime/src/kmp_gsupport.cpp
1267

could we have something other than 8 in the condition? Is there an enum value or can we create at least a local variable with the value?

jlpeyton updated this revision to Diff 291081.Sep 10 2020, 2:15 PM

Added enum for GOMP task flags.

jlpeyton updated this revision to Diff 291700.Sep 14 2020, 3:11 PM

Add #pragma omp task if(0) depend() version of taskwait depend test.

protze.joachim accepted this revision.Mon, Sep 21, 7:20 AM
protze.joachim added a subscriber: protze.joachim.

LGTM, the relevant OMPT tests pass with this patch

This revision is now accepted and ready to land.Mon, Sep 21, 7:20 AM
This revision was landed with ongoing or failed builds.Thu, Sep 24, 7:50 AM
This revision was automatically updated to reflect the committed changes.